'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty = require('babel-runtime/core-js/object/define-property');

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isPromise = function isPromise(obj) {
  return typeof obj !== 'undefined' && typeof obj.then === 'function';
};

var _runner = function _runner() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
      instance = _ref.instance,
      original = _ref.original;

  return function () {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    try {
      var returns = original.apply(instance, args);
      return isPromise(returns) ? returns.then(function (r) {
        return [null, r];
      }).catch(function (e) {
        return [e, null];
      }) : [null, returns];
    } catch (e) {
      return [e, null];
    }
  };
};

exports.default = function (target, fnName, descriptor) {
  var fn = descriptor.value,
      configurable = descriptor.configurable,
      enumerable = descriptor.enumerable;

  // https://github.com/jayphelps/core-decorators.js/blob/master/src/autobind.js

  return (0, _assign2.default)({}, {
    configurable: configurable,
    enumerable: enumerable,
    get: function get() {
      if (this === target) {
        return fn;
      }
      var _fnRunner = _runner({
        instance: this,
        original: fn
      });

      (0, _defineProperty2.default)(this, fnName, {
        configurable: true,
        writable: true,
        enumerable: false,
        value: _fnRunner
      });
      return _fnRunner;
    },
    set: function set(newValue) {
      (0, _defineProperty2.default)(this, fnName, {
        configurable: true,
        writable: true,
        enumerable: true,
        value: newValue
      });

      return newValue;
    }
  });
};